#include <stdio.h>
#include <stdint.h>
#include <stdlib.h>

#pragma warning(disable : 4996)
#pragma pack(1)

typedef unsigned short int WORD;
typedef unsigned long int DWORD;
typedef unsigned char BYTE;

typedef struct _WinBMPFileHeader
{
	WORD  FileType;
	DWORD FileSize;
	WORD  Reserved1;
	WORD  Reserved2;
	DWORD BitMapOffset;
} WINBMPHEADER;

typedef struct _BitmapHeader
{
	uint32_t Size;            /* Size of this header in bytes */
	uint32_t Width;           /* Image width in pixels */
	uint32_t Height;          /* Image height in pixels */
	uint16_t  Planes;         /* Number of color planes */
	uint16_t  BitsPerPixel;   /* Number of bits per pixel */
	uint32_t Compression;     /* Compression methods used */
	uint32_t SizeOfBitmap;    /* Size of bitmap in bytes */
	uint32_t HorzResolution;  /* Horizontal resolution in pixels per meter */
	uint32_t VertResolution;  /* Vertical resolution in pixels per meter */
	uint32_t ColorsUsed;      /* Number of colors in the image */
	uint32_t ColorsImportant; /* Minimum number of important colors */
} BitmapHeader;


#define fname1 "intelww4.bmp"

#define tstbit(x,n) (((x)>>(n))&1)

void VypisBuf(const char *name, void* adr, int size)
{
	int i;
	puts(name);
	printf("Adresa: %p  Velikost: %d\n", adr, size);
	puts("-------------------------------------------");
	for (i = 0; i < size; i++)
	{
		printf("%02X ", ((unsigned char*)adr)[i]);
		if ((i & 7) == 7) putchar('\n');
	}
	putchar('\n');
	if (i & 7) putchar('\n');
}

int pixel(unsigned char* buf, int r, int s, int vyska, int sirka)
{
	unsigned char c, b;
	c = buf[(vyska - r - 1) * (sirka / 8) + s / 8];
	b = 7 - (s & 7);
	return tstbit(c, b);
}

int main()
{
	WINBMPHEADER h;
	BitmapHeader bh;
	FILE* f;
	unsigned char* buf;
	int size;
	int r, s;
	char zn[2] = { ' ', '*' };
	f = fopen(fname1, "rb");
	if (f == NULL)
	{
		printf("Soubor %s nelze otevrit\n", fname1);
		return 1;
	}
	fread(&h, 1, sizeof(h), f);
	VypisBuf("BMP header", &h, sizeof(h));
	fread(&bh, 1, sizeof(bh), f);
	VypisBuf("Bitmap header", &bh, sizeof(bh));
	size = bh.Width * bh.Height / 8;
	printf("Sirka: %d, Vyska: %d bit/pix: %d  Size: %d\n\n", bh.Width, bh.Height, bh.BitsPerPixel, size);
	buf = (unsigned char*)malloc(size);
	if (buf == NULL)
	{
		printf("Neni dost pameti!\n");
		return 1;
	}
	fseek(f, h.BitMapOffset, 0);
	fread(buf, 1, size, f);
	VypisBuf("Image data", buf, size);
	fclose(f);
	for (r = 0; r < bh.Height; r++)
	{
		for (s = 0; s < bh.Width; s++)
		{
			putchar(zn[pixel(buf, r, s, bh.Height, bh.Width)]);
		}
		putchar('\n');
	}


	free(buf);
	return 0;
}

