#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include "ModulA.h"

uint8_t* alloc_bytes(int size)
{
	uint8_t* adr;
	adr = (uint8_t*)malloc(size);
	if (adr == NULL)
	{
		puts("Memory allocation error!");
	}
	return adr;
}

int *alloc_ints(int size)
{
	int* adr;
	adr = (int*)malloc(size*sizeof(int));
	if (adr == NULL)
	{
		puts("Memory allocation error!");
	}
	return adr;
}

void dealloc(void* adr)
{
	if (adr) free(adr);
}

void dump(void* adr, int size)
{
	int i;
	uint8_t* a = (uint8_t*)adr;
	printf("Address: %p  Size: %d\n", a, size);
	puts("-------------------------------------------");
	for (i = 0; i < size; i++)
	{
		if ((i&7)==0) printf("%p  ", a);
		printf("%02X ", *a);
		if ((i & 7) == 7) putchar('\n');
		a++;
	}
	putchar('\n');
	if (i & 7) putchar('\n');
}

uint8_t *getfile(const char* fname, int *size)
{
	FILE *f;
	int sz;
	uint8_t* adr;
	f = fopen(fname, "rb");
	if (f == NULL)
	{
		printf("Open file %s failed\n", fname);
		return NULL;
	}
	fseek(f, 0, SEEK_END);
	sz = ftell(f);
	fseek(f, 0, SEEK_SET);
	adr = alloc_bytes(sz);
	if (adr)
	{
		fread(adr, 1, sz, f);
		fclose(f);
		*size = sz;
	}
	return adr;
}