#include "ModulB.h"
#include <stdio.h>

bmp read_bmp(const char* fname)
{
	bmp B;
	uint8_t* bf;
	int size;
	int x;
	bf = getfile(fname, &size);
	B.bff = bf;
	if (bf)
	{
		B.filesize = size;
		x = ((WINBMPHEADER*)bf)->BitMapOffset;
		B.buf = bf + x;
		B.height = ((BitmapHeader*)(bf + sizeof(WINBMPHEADER)))->Height;
		B.width = ((BitmapHeader*)(bf + sizeof(WINBMPHEADER)))->Width;
		B.bits = ((BitmapHeader*)(bf + sizeof(WINBMPHEADER)))->BitsPerPixel;
		x = ((B.width * B.bits + 31) / 32) * 4;
		B.imagesize = B.height * x;
	}
	return B;
}

int pixel(unsigned char* buf, int row, int col, int height, int width)
{
	unsigned char c, b;
	int w;
	w = ((width + 31) / 32) * 4;
	c = buf[(height - row - 1) * w + col / 8];
	b = 7 - (col & 7);
	return tstbit(c, b);
}

void show_bmp_data(bmp image)
{
	char zn[2] = { 2, ' ' };
	int row, col;
	printf("Filesize: %d\n", image.filesize);
	printf("Width: %d, Height: %d bit/pix: %d  Size: %d\n\n", image.width, image.height, image.bits, image.imagesize);
	for (row = 0; row < image.height; row++)
	{
		for (col = 0; col < image.width; col++)
		{
			putchar(zn[pixel((unsigned char*)image.buf, row, col, image.height, image.width)]);
		}
		putchar('\n');
	}


}

