#ifndef ModulB_h
#define ModulB_h


#pragma pack(1)
#include <stdint.h>
#include "ModulA.h"

typedef struct _WinBMPFileHeader
{
	uint16_t  FileType;
	uint32_t  FileSize;
	uint16_t  Reserved1;
	uint16_t  Reserved2;
	uint32_t BitMapOffset;
} WINBMPHEADER;

typedef struct _BitmapHeader
{
	uint32_t Size;            /* Size of this header in bytes */
	uint32_t Width;           /* Image width in pixels */
	uint32_t Height;          /* Image height in pixels */
	uint16_t  Planes;         /* Number of color planes */
	uint16_t  BitsPerPixel;   /* Number of bits per pixel */
	uint32_t Compression;     /* Compression methods used */
	uint32_t SizeOfBitmap;    /* Size of bitmap in bytes */
	uint32_t HorzResolution;  /* Horizontal resolution in pixels per meter */
	uint32_t VertResolution;  /* Vertical resolution in pixels per meter */
	uint32_t ColorsUsed;      /* Number of colors in the image */
	uint32_t ColorsImportant; /* Minimum number of important colors */
} BitmapHeader;

typedef struct
{
	void* bff;
	void* buf;
	int filesize;
	int imagesize;
	int width;
	int height;
	int bits;
} bmp;

#define tstbit(x,n) (((x)>>(n))&1)

bmp read_bmp(const char* fname);
void show_bmp_data(bmp image);

#endif